// made by http://kldp.org/minipage/primewizard
// EmacsHooker.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "EmacsHooker.h"

#include <map>
//using namespace std;

HINSTANCE hMod = NULL;
HHOOK hHook=NULL;

typedef std::map<HWND, HIMC>			IMCMap;
typedef std::map<HWND, HIMC>::iterator	IMCIt;

IMCMap imcs;

LRESULT CALLBACK CallWndProc(int code,  WPARAM w,  LPARAM l);

BOOL APIENTRY DllMain( HINSTANCE hinstDLL, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	hMod = hinstDLL;

	if (ul_reason_for_call == DLL_PROCESS_DETACH)		
		UninstallHook();

    return TRUE;
}

LRESULT __declspec(dllexport) InstallHook(void)
{
	try
	{
		hHook = SetWindowsHookEx(WH_CALLWNDPROC, CallWndProc , hMod, 0);
	}
	catch(...)
	{
		if(hHook)
		{
			if(::UnhookWindowsHookEx(hHook))
				hHook = NULL;
		}
	}

	return 0;
}

LRESULT __declspec(dllexport) UninstallHook(void)
{
	
	if(hHook)
	{
		if(::UnhookWindowsHookEx(hHook))
			hHook = NULL;
	}

	for(IMCIt it=imcs.begin(); it != imcs.end(); it++)
	{
		if(::IsWindow(it->first))
			::ImmAssociateContext(it->first, it->second);
	}
	
	return 0;
}

LRESULT CALLBACK CallWndProc(int code,  WPARAM w,  LPARAM l)
{
	if(code < 0)
		return CallNextHookEx(NULL, code, w, l);

	CWPSTRUCT *cwp = (CWPSTRUCT *)l;

	char szClassName[32];
	::GetClassName(cwp->hwnd,szClassName,32);
	if(!strcmp(szClassName,"Emacs"))
	{
		if ( cwp->message == WM_CREATE)
   		{	
			HIMC hIMC = ::ImmAssociateContext(cwp->hwnd,NULL);
			imcs[cwp->hwnd] = hIMC;
   		}

		if ( cwp->message == WM_SETFOCUS)
   		{	
			if(imcs.find(cwp->hwnd) == imcs.end())
			{
				HIMC hIMC = ::ImmAssociateContext(cwp->hwnd,NULL);
				imcs[cwp->hwnd] = hIMC;
			}
   		}

		if ( cwp->message == WM_CLOSE)
   		{	
			IMCIt it = imcs.find(cwp->hwnd);
			if(it != imcs.end())
			{
				//::ImmAssociateContext(it->first, it->second);
				imcs.erase(it);
			}
   		}

	}

	return CallNextHookEx(hHook, code,  w, l);
}
